#include "testlib.h" // Egor.Lifar orz
#include <iostream>
#include <cassert>
#include <map>
#include <numeric>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <vector>
#include <cassert>
#define all(c) (c).begin(), (c).end() 
#define pii pair<int, int>
#define pb push_back
using namespace std;
 
 
const int MAX_N = 200'000;
const int MAX_M = 1'000'000'000;
const int MAX_T = 1'000'000'000;
 
struct Constraints {
    int maxN, maxM, maxT;
};
 
vector<Constraints> groups = {
    {MAX_N, MAX_M, MAX_T}, 
    {500, 100, MAX_T},
    {MAX_N, 100, MAX_T},
    {500, MAX_M, 500},
    {5000, MAX_M, 500},
    {MAX_N, MAX_M, MAX_T}
};
 
/*
0) samples
1) small n, m
2) small m
3) small n, t
4) small t
5) full
*/
 
map<string, string> params = {{"type", "random"}, {"group", "5"}};
set<string> options; 
 
void parseParams(int argc, char* argv[]) {
    for (int i = 1; i < argc; ++i) {
        string param(argv[i]);
        auto pos = param.find('=');
        if (pos == string::npos) {
            options.insert(param);
        } else {
            params[param.substr(0, pos)] = param.substr(pos + 1);
        }
    }
}
 
int groupID;
int n, m, mx, ans_;
vector<int> t;
 
void print() {
    cout << t.size() << " " << m << "\n";
    for (int i = 0; i < t.size(); ++i) {
        if (i) cout << " ";
        cout << t[i];
    }
    cout << "\n";
}
 
void block(int cur, int l, int r) {
    // have max(t_i) = cur, want to block m in [l, r]
    if (l > r) return;
    if (cur % m != (l - 1 + m) % m) {
        int add = ((l - 1 + m) % m - cur % m + m) % m;
        cur += add;
        t.pb(cur);
    }
    t.pb(cur + r - l + 1 + m);
    assert(cur + r - l + 1 + m <= groups[groupID].maxT);
}
 
void add(int lft = 0) {
    assert(!t.empty());
    int nxt = t.back() + rnd.next(1, m);
    if (nxt + m * 4ll * lft <= mx) {
        t.pb(nxt);
    } else {
        t.pb(t.back());
    }
}
 
void generate() {
    /*
    FOR SMALL N (< 10) ONLY POSSIBLE TESTS ARE RANDOM
    OTHERWISE FOR MEANINGFUL TESTS: MAX_T > 10 * M
    */
 
    if (params.find("n") != params.end()) {
        n = stoi(params["n"]);
    } else {
        n = rnd.next(1, groups[groupID].maxN);
    }
    if (params.find("m") != params.end()) {
        m = stoi(params["m"]);
    } else {
        m = rnd.next(1, groups[groupID].maxM);
    }
    if (params.find("mx") != params.end()) {
        mx = stoi(params["mx"]);
    } else {
        mx = groups[groupID].maxT;
    }
    if (params.find("ans") != params.end()) {
        ans_ = stoi(params["ans"]);
    } else {
        ans_ = rnd.next(0, m - 1);
    }
 
    if (params["type"] == "sample1") {
        n = 3;
        m = 3;
        t = {4, 5, 10};
    } else if (params["type"] == "sample2") {
        n = 4;
        m = 5;
        t = {2, 4, 14, 17};
    } else if (params["type"] == "random") {
        for (int i = 0; i < n; ++i) {
            t.push_back(rnd.next(0, mx));
        }
    } else if (params["type"] == "ans") {
        t.pb(rnd.next(0, min(mx / 4, 100)));
        vector<pii> blocks;
        int segs = rnd.next(1, (int)min(n / 4ll, mx / (3ll * m))) - 1; // total number of segments
        if (ans_ > 0) {
            vector<int> have;
            have.pb(0);
            have.pb(ans_);
            int blocksnum = rnd.next(0, segs);
            for (int i = 0; i < blocksnum; ++i) {
                have.pb(rnd.next(0, ans_));
            }
            sort(all(have));
            have.resize(unique(all(have)) - have.begin());
            for (int i = 1; i < have.size(); ++i) {
                blocks.pb({have[i - 1], have[i] - 1});
            }
        }
        int L = 0, R = max(ans_ - 1, 0);
        if (ans_ < m - 1 - ans_) {
            L = ans_ + 1;
            R = m - 1;
        }
        int freenum = segs - blocks.size();
        for (int i = 0; i < freenum; ++i) {
            int curl = rnd.next(L, R);
            int curr = rnd.next(L, R);
            if (curl > curr) swap(curl, curr);
            blocks.pb({curl, curr});
        }
        int sz = blocks.size();
        vector<int> addbefore(sz, 0);
        if (sz && n - 2 * sz > 0) {
            int it = rnd.next(0, n - 2 * sz);
            for (int i = 0; i < it; ++i) {
                addbefore[rnd.next(0, sz - 1)]++;
            }
        }
        for (int i = 0; i < sz; ++i) {
            for (int j = 0; j < addbefore[i]; ++j) {
                add(sz - i);
            }
            block(t.back(), blocks[i].first, blocks[i].second);
        }
        while (t.size() < n) {
            add();
        }
    } else {
        assert(false);
    }
 
    sort(all(t));
}
 
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    parseParams(argc, argv);
    groupID = stoi(params["group"]);
    generate();
    print();
}

